<?php

namespace Zeedhi\Translate\Controller;

use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\DataSet;

class Login extends Simple
{
    public function login(Request\Filter $request, Response $response) {
        $conditions = $request->getFilterCriteria()->getConditions();
        if (isset($conditions)) {
            $usermail = $conditions[0]['value'];
            $password = $conditions[1]['value'];
            $flagTry = false;

            /*If both user email and password are filled out,
            then the system looks up the user in the databse.*/
            /** @var ZhUser $userEntity */
            $userEntity = null;
            if ($usermail != null && $password != null){
                $userEntity = ($usermail == 'dev@teknisa.com') && ($password == '123');
                //Auxiliary variable to handle ammount of times an error message shows up.
                $flagTry = true;
            } /*If field user email is left blank, show an error message.*/
            else if ($usermail == '') {
                $response->addMessage(new Message ("Please enter your email."));
            } /*If the password field is left blank, show an error message;*/
            else if ($password == '') {
                $response->addMessage(new Message ("Please enter your password."));
            }

            /*If the findOneBy search fails, then show an error message.*/
            if ($userEntity == false) {
                if ($flagTry) {
                    $response->addMessage(new Message ("Your email or password is incorrect. \nPlease try again."));
                }
            } /*If the Login succeeds, then proceed to the Reports page.*/
            else {
                $resultSet = [$userEntity];
                $response->addDataSet(new DataSet('login', array($resultSet)));
            }
        } else {
            $response->addMessage(new Message ("Please enter your email and password!"));
        }
    }
}