/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ITEMTAREFA                                               */
/* Tabela : ITEMTAREFA                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 27/05/2010 - Tarcsio Dias Pereira                                         */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ITEMTAREFA
BEFORE INSERT OR UPDATE OR DELETE
ON ITEMTAREFA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,0) <> NVL(:NEW.CDFILIAL,0)) OR
         (NVL(:OLD.NRTAREFA,0) <> NVL(:NEW.NRTAREFA,0)) OR
         (NVL(:OLD.NRSEQUITTARE,0) <> NVL(:NEW.NRSEQUITTARE,0)) OR
         (NVL(:OLD.DSREFEITTARE,0) <> NVL(:NEW.DSREFEITTARE,0)) OR
         (NVL(:OLD.CDOPERADOR,0) <> NVL(:NEW.CDOPERADOR,0)) OR
         (NVL(:OLD.TXPLANITTARE,0) <> NVL(:NEW.TXPLANITTARE,0)) OR
         (NVL(:OLD.CDOPERRESP,0) <> NVL(:NEW.CDOPERRESP,0)) OR
         (NVL(:OLD.NRPRIOITTARE,0) <> NVL(:NEW.NRPRIOITTARE,0)) OR
         (NVL(:OLD.CDITEMTRAB,0) <> NVL(:NEW.CDITEMTRAB,0)) OR
         (NVL(:OLD.NRCPLXITEMTB,0) <> NVL(:NEW.NRCPLXITEMTB,0)) OR
         (NVL(:OLD.NRCPLXIMPLEM,0) <> NVL(:NEW.NRCPLXIMPLEM,0)) OR
         (NVL(:OLD.NRCPLXITTARE,0) <> NVL(:NEW.NRCPLXITTARE,0)) OR
         (NVL(:OLD.IDCONCATTARE,0) <> NVL(:NEW.IDCONCATTARE,0)) THEN
	:NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ITEMTAREFA', '', 'CDFILIAL ='||:OLD.CDFILIAL||';NRTAREFA ='||:OLD.NRTAREFA||';NRSEQUITTARE ='||:OLD.NRSEQUITTARE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ITEMTAREFA MODIFY DTULTATU DEFAULT SYSDATE;
/ 